package{
  import flash.display.Sprite;
  import flash.display.Stage;
  import flash.events.Event;
  import flash.events.MouseEvent;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import component.Button;
  import component.ComboBox;
  import component.TextBox;

//--------------------------------------------------------------------//
// ANVǗNX
  public class DropActionManager{

// pxWAɕϊW
    public static const TO_RADIAN:Number=Math.PI/180.0;

// Xe[W
    internal var stage:Stage;

// tH\f
    internal var view:DropViewModel;

// }EX{^Ă邩ǂ
    internal var pressed:Boolean;

// }EXʒu
    internal var mx:int;
    internal var my:int;

// \IR{{bNX
    internal var perspect:ComboBox;

// W̓tB[h
    internal var beta:TextField;

// ڐGp̓tB[h
    internal var gamma:TextField;

//--------------------------------------------------------------------//
// sprite - eXvCg
// view - tH\f
// x,y,width - \ʒuAA
// textFormat - eLXg
    public function DropActionManager(sprite:Sprite,view:DropViewModel,
      	      	      	      	      x:int,y:int,width:int,
      	      	      	      	      textFormat:TextFormat){
      stage=sprite.stage;
      this.view=view;
      stage.addEventListener(MouseEvent.MOUSE_DOWN,mousePressed);
      stage.addEventListener(MouseEvent.MOUSE_UP,mouseReleased);
      stage.addEventListener(MouseEvent.MOUSE_MOVE,mouseMoved);
      pressed=false;
      mx=0;
      my=0;
      addButtons(sprite,x,y,width,textFormat);
    }

//--------------------------------------------------------------------//
// {^ǉ
// sprite - eXvCg
// x,y,width - \ʒuA
// textFormat - eLXg
    internal function addButtons(sprite:Sprite,x:int,y:int,
      	      	      	      	 width:int,textFormat:TextFormat):void{
      var bgColor:uint=0xffffff;
      var fgColor:uint=0x000000;

      var pers:Vector.<String>=
      	Vector.<String>(["non-perspect","perspect"]);

      var w:int=width/8;
      perspect=new ComboBox(pers,fgColor,bgColor,x,y,
      	      	      	    textFormat,ComboBox.ABOVE,0);

      perspect.addEventListener(ComboBox.SELECT,selectPerspect);

      var bLabel:TextField=createLabelField("beta:",x+2*w,y,
      	      	      	      	      	    textFormat);
      beta=createInputField(String(view.beta),right(bLabel),y,w,fgColor,
      	      	      	    textFormat);

      var gLabel:TextField=createLabelField("contact angle:",
      	      	      	      	      	    right(beta),y,textFormat);
      gamma=createInputField(String(view.gamma/TO_RADIAN),right(gLabel),
      	      	      	     y,w,fgColor,textFormat);

      var drawButton:Button=new Button("Draw",fgColor,bgColor,
      	      	      	      	       right(gamma),y,
      	      	      	      	       textFormat);
      drawButton.addEventListener(MouseEvent.CLICK,draw);

      sprite.addChild(perspect);
      sprite.addChild(bLabel);
      sprite.addChild(beta);
      sprite.addChild(gLabel);
      sprite.addChild(gamma);
      sprite.addChild(drawButton);
    }

//--------------------------------------------------------------------//
// xpeLXgtB[h쐬
// s - eLXg
// x,y - \ʒu
// textFormat - eLXg
    internal function createLabelField(s:String,x:Number,y:Number,
      	      	      	      	       textFormat:TextFormat):TextField{
      var field:TextField=new TextField();
      field.text=s;
      field.selectable=false;
      field.x=x;
      field.y=y;
      field.width=field.textWidth+TextBox.CL;
      field.height=field.textHeight+TextBox.CL;
      field.background=true;
      field.defaultTextFormat=textFormat;
      return field;
    }


//--------------------------------------------------------------------//
// ͗peLXgtB[h쐬
// s - eLXg
// x,y,w - \ʒuA
// fgColor - OiF
// textFormat - eLXg
    internal function createInputField(s:String,x:Number,y:Number,
      	      	      	      	       w:Number,fgColor:uint,
      	      	      	      	       textFormat:TextFormat):TextField{
      var field:TextField=new TextField();
      field.text=s;
      field.border=true;
      field.selectable=true;
      field.x=x;
      field.y=y;
      field.width=w;
      field.height=field.textHeight+TextBox.CL;
      field.background=true;
      field.borderColor=fgColor;
      field.defaultTextFormat=textFormat;
      field.type="input";
      return field;
    }

//--------------------------------------------------------------------//
// eLXgtB[h̉ẼR|[lg̍WԂ
// field - eLXgtB[h
    internal function right(field:TextField):int{
      return field.x+field.width+TextBox.CL
    }

//--------------------------------------------------------------------//
// }EX{^̏s
    internal function mousePressed(event:MouseEvent):void{
      pressed=true;
      mx=stage.mouseX;
      my=stage.mouseY;
    }

//--------------------------------------------------------------------//
// }EX{^𗣂̏s
    internal function mouseReleased(event:MouseEvent):void{
      pressed=false;
    }

//--------------------------------------------------------------------//
// }EX{^ړ̏s
    internal function mouseMoved(event:MouseEvent):void{
      if(pressed){
      	view.rotate(mx-stage.mouseX,my-stage.mouseY);
      	mx=stage.mouseX;
      	my=stage.mouseY;
      	view.draw();
      }
    }

//--------------------------------------------------------------------//
// \ (ϊ) ؂ւ
    internal function selectPerspect(event:Event):void{
      view.setPerspect(perspect.index==1);
    }

//--------------------------------------------------------------------//
// ĕ`悷
    internal function draw(event:Event):void{
      try{
      	view.setParameters(Number(beta.text),
      	      	      	   TO_RADIAN*Number(gamma.text));
      }
      catch(e:Error){
      }
    }
  }
}
