package{
  import flash.display.BitmapData;
  import flash.geom.Vector3D;
  import figure.Point3D;
  import figure.Polygon3D;
  import figure.Rotate;
  import shading.Shading;
  import shading.FlatShading;
  import shading.GouraudShading;

//--------------------------------------------------------------------//
// tHf[^f
  public class DropModel{

// tbgVF[fBO
    public static const FLAT_SHADING:uint=1;
// O[[VF[fBO
    public static const GOURAUD_SHADING:uint=2;

// tH`̃f[^
    public static const NMAX:int=181;

// pxWAɕϊW
    public static const TO_RADIAN:Number=Math.PI/180.0;

// ̐F
    public static const FLOOR_COLOR:uint=0x3333ff;

// tH̐F
    public static const DROP_COLOR:uint=0x00ffff;

// tH
    public var drop:Rotate;

// 
    public var floor:Polygon3D;

// _
    public var viewPoint:Point3D;

// 
    public var lightPoint:Point3D;

// ʃTCY
    public var frameSize:Number;

// tH̍
    public var height:Number;

// tH̑̐
    public var volume:Number;

//--------------------------------------------------------------------//
// tHf[^f\z
// width,height - ʃTCY
    public function DropModel(width:Number,height:Number):void{
      frameSize=Math.min(width,height);
      height=0.0;
      volume=0.0;
      setArround();
    }

//--------------------------------------------------------------------//
// ӂݒ肷
    internal function setArround():void{

// ݒ肷
      var floorSize:Number=0.8*frameSize;
      var p:Vector.<Point3D>=Vector.<Point3D>
      	([new Point3D(floorSize,floorSize,0.0),
      	  new Point3D(-floorSize,floorSize,0.0),
      	  new Point3D(-floorSize,-floorSize,0.0),
      	  new Point3D(floorSize,-floorSize,0.0)]);
      floor=new Polygon3D(p);
      floor.setColor(FLOOR_COLOR);

// _ݒ肷
      var viewCoord:Number=1.6*frameSize;
      viewPoint=new Point3D(viewCoord,viewCoord,viewCoord);

// ݒ肷
      lightPoint=new Point3D(0.0,1.4*frameSize,3.0*frameSize);
    }

//--------------------------------------------------------------------//
// tHݒ肷
// beta - W 
// gamma0 - ڐGp
    public function setDrop(beta:Number,gamma0:Number):void{
      var r:Vector.<Number>=new Vector.<Number>(NMAX,true);
      var f:Vector.<Number>=new Vector.<Number>(NMAX,true);
      var df:Vector.<Number>=new Vector.<Number>(NMAX,true);
      var gamma:Vector.<Number>=new Vector.<Number>(NMAX,true);
      var vol:Vector.<Number>=new Vector.<Number>(NMAX,true);

      var dth:Number=Math.PI/Number(NMAX-1);
      var n:int=DropShape.ABMMethodP(NMAX,dth,r,f,df,gamma,gamma0,beta);

      var rbc:Number=f[n-1];
      for(var i:int=0;i<n;i++){
      	var th:Number=r[i];
      	var rr:Number=f[i];
      	r[i]=rr*Math.sin(th);
      	f[i]=rr*Math.cos(th);
      }
      var dv:Number=Math.PI/3.0;
      vol[0]=0.0;
      for(i=1;i<n;i++){
      	vol[i]=vol[i-1]+dv*(f[i-1]-f[i])*(r[i-1]*(r[i-1]+r[i])
      	      	      	   +r[i]*r[i]);
      }
      var r0:Number=0.0;
      var f0:Number=0.0;
      if((gamma0<gamma[n-1]) && (rbc>Number.MIN_VALUE)){
      	r0=InterPolation.linear(n,gamma0,gamma,r);
      	f0=InterPolation.linear(n,gamma0,gamma,f);
      	volume=InterPolation.linear(n,gamma0,gamma,vol)/(r0*r0*r0);
      }
      else{
      	r0=r[n-2];
      	f0=f[n-2];
      	volume=vol[n-2]/(r0*r0*r0);
      }
      height=Math.abs((f0-1.0)/r0);
      rr=0.3*frameSize/r0;
      var ii:int=1;
      while(f0<f[ii]) ii++;
      n=ii+1;
      r[ii]=r0;
      f[ii]=f0;
      for(i=0;i<n;i++){
      	r[i]*=rr;
      	f[i]=rr*(f[i]-f0);
      }
      var org:Point3D=new Point3D();
      var axis:Vector3D=new Vector3D(0.0,0.0,1.0);
      drop=new Rotate(org,axis,n,f,r);
      drop.setColor(DROP_COLOR);
    }

//--------------------------------------------------------------------//
// _ʒu]
// theta,phy - oxEܓx
    public function viewRotate(theta:Number,phy:Number):void{
      var dxy:Number=viewPoint.x*viewPoint.x+viewPoint.y*viewPoint.y;
      if(dxy>Number.MIN_VALUE){
      	dxy=Math.sqrt(dxy);
      	var th1:Number=Math.atan2(viewPoint.y,viewPoint.x);

      	pRotZ(viewPoint,-th1);
      	var th2:Number=Math.atan(viewPoint.z/dxy)/TO_RADIAN;
      	phy=Math.max(Math.min(phy,89.0+th2),-89.0+th2);
      	pRotY(viewPoint,TO_RADIAN*phy);
      	pRotZ(viewPoint,th1);
      }
      pRotZ(viewPoint,TO_RADIAN*theta);
    }

//--------------------------------------------------------------------//
// VF[fBO`vZ
// type - VF[fBO̎ނ\ int ^
// perspect - ϊꍇ true
// bgColor - wiF
// width,height - ʃTCY
// image - ʕ\摜
// zbuf - zW̃obt@Xg
    public function getPixel(type:int,perspect:Boolean,bgColor:uint,
      	      	      	     width:int,height:int,
      	      	      	     image:BitmapData,zbuf:Array):void{
      image.lock();
      for(var i:int=0;i<width;i++){
      	for(var j:int=0;j<height;j++){
      	  image.setPixel(i,j,bgColor);
      	  zbuf[i][j]=-Number.MAX_VALUE;
      	}
      }
      var shade:Shading=null;
      switch(type){
      	case FLAT_SHADING:
      	  shade=new FlatShading(width,height,viewPoint,lightPoint,
      	      	      	      	perspect);
      	  break;
      	case GOURAUD_SHADING:
      	  shade=new GouraudShading(width,height,viewPoint,lightPoint,
      	      	      	      	   perspect);
      	  break;
      }
      shade.polygons(drop,image,zbuf);
      shade.polygon(floor,image,zbuf);
      image.unlock();
    }

//--------------------------------------------------------------------//
// _yɉ]
// p - ]_
// theta - ]p
    internal function pRotY(p:Point3D,theta:Number):void{
      var cc:Number=Math.cos(theta);
      var ss:Number=Math.sin(theta);
      var tz:Number=cc*p.z-ss*p.x;
      var tx:Number=ss*p.z+cc*p.x;
      p.x=tx;
      p.z=tz;
    }

//--------------------------------------------------------------------//
// _zɉ]
// p - ]_
// theta - ]p
    internal function pRotZ(p:Point3D,theta:Number):void{
      var cc:Number=Math.cos(theta);
      var ss:Number=Math.sin(theta);
      var tx:Number=cc*p.x-ss*p.y;
      var ty:Number=ss*p.x+cc*p.y;
      p.x=tx;
      p.y=ty;
    }
  }
}
