package{

//--------------------------------------------------------------------//
// tH`쐬NX
  public class DropShape{

// fW1K̍ől
    public static const DFLIMIT:Number=1.0E5;

// A_X|oVtH[X|[g@̗\qW̃Xg
    public static const CP:Array=
      [Vector.<Number>([1.0]),
       Vector.<Number>([1.5,-0.5]),
       Vector.<Number>([23.0/12.0,-16.0/12.0,5.0/12.0]),
       Vector.<Number>([55.0/24.0,-59.0/24.0,37.0/24.0,-9.0/24.0]),
       Vector.<Number>([1901.0/720.0,-277.0/720.0,2616.0/720.0,
      	      	      	-1274.0/720.0,251.0/720.0])];

// A_X|oVtH[X|[g@̕␳qW̃Xg
    public static const CC:Array=
      [Vector.<Number>([0.5,0.5]),
       Vector.<Number>([0.5,0.5]),
       Vector.<Number>([5.0/12.0,8.0/12.0,-1.0/12.0]),
       Vector.<Number>([9.0/24.0,19.0/24.0,-5.0/24.0,1.0/24.0]),
       Vector.<Number>([251.0/720.0,646.0/720.0,-264.0/720.0,
      	      	      	106.0/720.0,-19.0/720.0])];

//--------------------------------------------------------------------//
// A_X|oVtH[X|[g@ (W) ŉtH`쐬
// n - f[^_̍ől
// r0 - rW̏l
// dr0 - rW̑̏l
// r,f - r,fW̃Xg
// df - fW1Ki[郊Xg
// beta - W
// Ԃl - ۂ̃f[^_
    public static function ABMMethodC(n:int,r0:Number,dr0:Number,
      	      	      	      	      r:Vector.<Number>,
      	      	      	      	      f:Vector.<Number>,
      	      	      	      	      df:Vector.<Number>,
      	      	      	      	      beta:Number):int{
      var ff:Vector.<Number>=new Vector.<Number>(n,true);
      var dff:Vector.<Number>=new Vector.<Number>(n,true);
      r[0]=r0;
      f[0]=0.0;
      df[0]=0.0;
      ff[0]=df[0];
      dff[0]=laplaceD(r[0],f[0],df[0],beta);
      for(var i:int=1;i<n;i++){
      	var dr:Number=dr0/Math.sqrt(1.0+df[i-1]*df[i-1]);
      	r[i]=r[i-1]+dr;
      	var i2:int=Math.min(i-1,4);
      	var fp:Number=0.0;
      	var dfp:Number=0.0;
      	for(var j:int=0;j<CP[i2].length;j++){
      	  fp+=CP[i2][j]*ff[i-j-1];
      	  dfp+=CP[i2][j]*dff[i-j-1];
      	}
      	fp=f[i-1]+dr*fp;
      	dfp=df[i-1]+dr*dfp;
      	ff[i]=dfp;
      	dff[i]=laplaceD(r[i],fp,dfp,beta);
      	fp=0.0;
      	dfp=0.0;
      	for(j=0;j<CC[i2].length;j++){
      	  fp+=CC[i2][j]*ff[i-j];
      	  dfp+=CC[i2][j]*dff[i-j];
      	}
      	f[i]=f[i-1]+dr*fp;
      	df[i]=df[i-1]+dr*dfp;
      	if(Math.abs(df[i])>DFLIMIT){
      	  return i+1;
      	}
      }
      return n;
    }

//--------------------------------------------------------------------//
// A_X|oVtH[X|[g@ (ɍW) ŉtH`쐬
// n - f[^_̍ől
// dt - ƍW̑
// t,r - ,rW̃Xg
// dr - rW1Ki[郊Xg
// gamma - pxi[郊Xg
// gammaMax - ڐGp̍ől
// beta - W
// Ԃl - ۂ̃f[^_
    public static function ABMMethodP(n:int,dt:Number,t:Vector.<Number>,
      	      	      	      	      r:Vector.<Number>,
      	      	      	      	      dr:Vector.<Number>,
      	      	      	      	      gamma:Vector.<Number>,
      	      	      	      	      gammaMax:Number,beta:Number):int{
      var drr1:Vector.<Number>=new Vector.<Number>(n,true);
      var drr2:Vector.<Number>=new Vector.<Number>(n,true);
      t[0]=0.0;
      r[0]=1.0;
      dr[0]=0.0;
      drr1[0]=dr[0];
      drr2[0]=laplaceP(t[0],r[0],dr[0],beta);
      for(var i:int=1;i<n;i++){
      	t[i]=t[i-1]+dt;
      	var i2:int=Math.min(i-1,4);
      	var drp:Number=0.0;
      	var dr2p:Number=0.0;
      	for(var j:int=0;j<CP[i2].length;j++){
      	  drp+=CP[i2][j]*drr1[i-j-1];
      	  dr2p+=CP[i2][j]*drr2[i-j-1];
      	}
      	drp=r[i-1]+dt*drp;
      	dr2p=dr[i-1]+dt*dr2p;
      	drr1[i]=dr2p;
      	drr2[i]=laplaceP(t[i],drp,dr2p,beta);
      	drp=0.0;
      	dr2p=0.0;
      	for(j=0;j<CC[i2].length;j++){
      	  drp+=CC[i2][j]*drr1[i-j];
      	  dr2p+=CC[i2][j]*drr2[i-j];
      	}
      	r[i]=r[i-1]+dt*drp;
      	dr[i]=dr[i-1]+dt*dr2p;
      	var dy:Number=dr[i]*Math.cos(t[i])-r[i]*Math.sin(t[i]);
      	var dx:Number=dr[i]*Math.sin(t[i])+r[i]*Math.cos(t[i]);
      	if(Math.abs(dx)<=Number.MIN_VALUE){
      	  gamma[i]=0.5*Math.PI;
      	}
      	else if(dx<0.0){
      	  gamma[i]=Math.PI-Math.atan(dy/dx);
      	}
      	else{
      	  gamma[i]=-Math.atan(dy/dx);
      	}
      	if(dy>0.0) gamma[i]+=Math.PI;
      	if((gamma[i]>gammaMax) || (r[i]<=Number.MIN_VALUE)){
      	  return i+1;
      	}
      }
      return n;
    }

//--------------------------------------------------------------------//
// tH̃vX (W) fW2KvZĕԂ
// r - rW
// f - fW
// df - fW1K
// beta - W
    protected static function laplaceD(r:Number,f:Number,df:Number,
      	      	      	      	       beta:Number):Number{
      if(Math.abs(r)<=Number.MIN_VALUE){
      	return -1.0;
      }
      else{
      	var df2:Number=1.0+df*df;
      	return df2*(Math.sqrt(df2)*(beta*f-2.0)-df/r);
      }
    }

//--------------------------------------------------------------------//
// tH̃vX (ɍW) rW2KvZĕԂ
// t - ƍW
// r - rW
// dr - rW1K
// beta - W
    protected static function laplaceP(t:Number,r:Number,dr:Number,
      	      	      	      	       beta:Number):Number{
      if((Math.sin(t)<=Number.MIN_VALUE)
      || (Math.abs(r)<=Number.MIN_VALUE)){
      	return 0.0;
      }
      else{
      	var dr2:Number=r*r+dr*dr;
      	return dr2/r*(Math.sqrt(dr2)*(beta*(r*Math.cos(t)-1.0)-2.0)
      	      -(dr*Math.cos(t)/(r*Math.sin(t))-3.0))-r;
      }
    }
  }
}
