package{
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.text.TextField;
  import flash.text.TextFormat;
  import component.ViewModel;
  import figure.Point3D;

//--------------------------------------------------------------------//
// tH\f
  public class DropViewModel extends ViewModel{

// tHf[^f
    internal var model:DropModel;

// tH
    internal var info:DropInfo;

// ʕ\摜
    internal var image:Bitmap;

// zW̃obt@Xg
    internal var zbuf:Array;

// W 
    public var beta:Number;

// ڐGp
    public var gamma:Number;

// _]x
    internal var vx:Number;

// c_]x
    internal var vy:Number;

// ϊꍇ true
    protected var perspect:Boolean;

// wiF
    internal var bgColor:uint;

// OiF
    internal var fgColor:uint;

//--------------------------------------------------------------------//
// sprite - eXvCg
// model - tHf[^f
// graphics - `OtBbNX
// x,y,width,height - \ʒuAA
// fgColor - OiF
// bgColor - wiF
// textFormat - eLXg
    public function DropViewModel(sprite:Sprite,graphics:Graphics,
      	      	      	      	  x:int,y:int,width:int,height:int,
      	      	      	      	  fgColor:uint,bgColor:uint,
      	      	      	      	  textFormat:TextFormat){
      super(graphics,x,y,width,height);
      this.fgColor=fgColor;
      this.bgColor=bgColor;
      beta=0.1;
      gamma=Math.PI/2.0;
      vx=1.0;
      vy=1.0;
      perspect=false;
      info=new DropInfo(fgColor,bgColor,textFormat);

      image=new Bitmap();
      image.bitmapData=new BitmapData(region.width,region.height,
      	      	      	      	      false,bgColor);
      zbuf=new Array(int(region.width));
      for(var i:int=0;i<region.width;i++){
      	zbuf[i]=new Vector.<Number>(int(region.height),true);
      }
      sprite.addChild(image);
      sprite.addChild(info);
      setDraw();
    }

//--------------------------------------------------------------------//
// f]
// dx,dy - ʏ̈ړ
    public function rotate(dx:int,dy:int):void{
      model.viewRotate(vx*dx,vy*dy);
    }

//--------------------------------------------------------------------//
// p[^ݒ肷
// beta - W 
// gamma - ڐGp
    public function setParameters(beta:Number,gamma:Number):void{
      this.beta=beta;
      this.gamma=gamma;
      draw();
    }

//--------------------------------------------------------------------//
// ϊsǂݒ肷
// perspect - ϊsꍇ true
    public function setPerspect(perspect:Boolean):void{
      this.perspect=perspect;
      draw();
    }

//--------------------------------------------------------------------//
// `ݒ
    public function setDraw():void{
      var vCoef:Number=Math.min(region.width,region.height);
      vx=360.0*vx/vCoef;
      vy=360.0*vy/vCoef;
      model=new DropModel(region.width,region.height);
    }

//--------------------------------------------------------------------//
// `悷
    public function draw():void{
      drawInit(bgColor);
      model.setDrop(beta,gamma);
      model.getPixel(DropModel.GOURAUD_SHADING,perspect,bgColor,
      	      	     region.width,region.height,image.bitmapData,zbuf);
      info.draw(model);
    }
  }
}
