package figure{
  import flash.geom.Vector3D;

//--------------------------------------------------------------------//
// ]ʃNX
  public class Rotate implements PolygonCollection{

// ]̖ʂ̕
    public static const THETA:int=36;

// SxNg
    public var axis:Vector3D;

// |S̃Xg
    public var pl:Vector.<Polygon3D>;

//--------------------------------------------------------------------//
// ]ʂ\z
// p0 - _
// axis - ]xNg
// nx - ]֐̃f[^_̐
// x,y - x,yW̃Xg
    public function Rotate(p0:Point3D,axis:Vector3D,nx:int,
      	      	      	   x:Vector.<Number>,y:Vector.<Number>):void{
      var n:int=(nx-1)*THETA;
      pl=new Vector.<Polygon3D>(n,true);
      var dtheta:Number=2.0*Math.PI/Number(THETA);
      var cc:Number=Math.cos(dtheta);
      var ss:Number=Math.sin(dtheta);

      this.axis=axis;
      var x1:Number=x[0];
      var y1:Number=y[0];
      var vx1:Number=y[1]-y[0];
      var vy1:Number=-(x[1]-x[0]);
      var j0:int=0;
      for(var i:int=1;i<nx;i++){
      	var x2:Number=x[i];
      	var y2:Number=y[i];
      	var i1:int=int(Math.min(i+1,nx-1));
      	var vx2:Number=y[i1]-y[i-1];
      	var vy2:Number=-(x[i1]-x[i-1]);
      	if(y1==0.0){
      	  createUprCorn(y2,x1,x2,vx1,vy1,vx2,vy2,j0,THETA,cc,ss);
      	}
      	else if(y2==0.0){
      	  createLwrCorn(y1,x1,x2,vx1,vy1,vx2,vy2,j0,THETA,cc,ss);
      	}
      	else{
      	  createCylinder(x1,y1,x2,y2,vx1,vy1,vx2,vy2,j0,THETA,cc,ss);
      	}
      	x1=x2;
      	y1=y2;
      	vx1=vx2;
      	vy1=vy2;
      	j0+=THETA;
      }
    }

//--------------------------------------------------------------------//
// _ɂ~ʂ쐬
// y - ʂ̔a
// x1 - _̍W
// x2 - ʂ̍W
// vx1,vy1 - _̖@xNgx,y
// vx2,vy2 - ʂ̖@xNgx,y
// beginIndex - |Si[z̊JnCfbNX
// n - ]̖ʂ̕
// cc,ss - 1̖ʂ̊pxcos,sin
    internal function createUprCorn(y:Number,x1:Number,x2:Number,
      	      	      	      	    vx1:Number,vy1:Number,
      	      	      	      	    vx2:Number,vy2:Number,
      	      	      	      	    beginIndex:int,n:int,
      	      	      	      	    cc:Number,ss:Number):void{
      var p:Vector.<Point3D>=Vector.<Point3D>
      	([new Point3D(0.0,0.0,x1),new Point3D(y,0.0,x2),
      	  new Point3D(y,0.0,x2)]);
      var v:Vector.<Vector3D>=Vector.<Vector3D>
      	([new Vector3D(vy1,0.0,vx1,1.0),new Vector3D(vy2,0.0,vx2,1.0),
      	  new Vector3D(vy2,0.0,vx2,1.0)]);
      for(var i:int=0;i<n;i++){
      	pRotZ(p[2],cc,ss);
      	vRotZ(v[2],cc,ss);
      	pl[beginIndex+i]=new Polygon3D(p);
      	pl[beginIndex+i].setNormVector(v);
      	pRotZ(p[1],cc,ss);
      	vRotZ(v[1],cc,ss);
      }
    }

//--------------------------------------------------------------------//
// _ɂ~ʂ쐬
// y - ʂ̔a
// x1 - ʂ̍W
// x2 - _̍W
// vx1,vy1 - ʂ̖@xNgx,y
// vx2,vy2 - _̖@xNgx,y
// beginIndex - |Si[z̊JnCfbNX
// n - ]̖ʂ̕
// cc,ss - 1̖ʂ̊pxcos,sin
    internal function createLwrCorn(y:Number,x1:Number,x2:Number,
      	      	      	      	    vx1:Number,vy1:Number,
      	      	      	      	    vx2:Number,vy2:Number,
      	      	      	      	    beginIndex:int,n:int,
      	      	      	      	    cc:Number,ss:Number):void{
      var p:Vector.<Point3D>=Vector.<Point3D>
      	([new Point3D(y,0.0,x1),new Point3D(y,0.0,x1),
      	  new Point3D(0.0,0.0,x2)]);
      var v:Vector.<Vector3D>=Vector.<Vector3D>
      	([new Vector3D(vy1,0.0,vx1,1.0),new Vector3D(vy1,0.0,vx1,1.0),
      	  new Vector3D(vy2,0.0,vx2,1.0)]);
      for(var i:int=0;i<n;i++){
      	pRotZ(p[0],cc,ss);
      	vRotZ(v[0],cc,ss);
      	pl[beginIndex+i]=new Polygon3D(p);
      	pl[beginIndex+i].setNormVector(v);
      	pRotZ(p[1],cc,ss);
      	vRotZ(v[1],cc,ss);
      }
    }

//--------------------------------------------------------------------//
// `]ʂ쐬
// x1,y1 - ʂx,yW
// x2,y2 - ʂx,yW
// vx1,vy1 - ʂ̖@xNgx,y
// vx2,vy2 - ʂ̖@xNgx,y
// beginIndex - |Si[z̊JnCfbNX
// n - ]̖ʂ̕
// cc,ss - 1̖ʂ̊pxcos,sin
    internal function createCylinder(x1:Number,y1:Number,
      	      	      	      	     x2:Number,y2:Number,
      	      	      	      	     vx1:Number,vy1:Number,
      	      	      	      	     vx2:Number,vy2:Number,
      	      	      	      	     beginIndex:int,n:int,
      	      	      	      	     cc:Number,ss:Number):void{
      var p:Vector.<Point3D>=Vector.<Point3D>
      	([new Point3D(y1,0.0,x1),new Point3D(y1,0.0,x1),
      	  new Point3D(y2,0.0,x2),new Point3D(y2,0.0,x2)]);
      var v:Vector.<Vector3D>=Vector.<Vector3D>
      	([new Vector3D(vy1,0.0,vx1,1.0),new Vector3D(vy1,0.0,vx1,1.0),
      	  new Vector3D(vy2,0.0,vx2,1.0),new Vector3D(vy2,0.0,vx2,1.0)]);
      for(var i:int=0;i<n;i++){
      	pRotZ(p[0],cc,ss);
      	pRotZ(p[3],cc,ss);
      	vRotZ(v[0],cc,ss);
      	vRotZ(v[3],cc,ss);
      	pl[beginIndex+i]=new Polygon3D(p);
      	pl[beginIndex+i].setNormVector(v);
      	pRotZ(p[1],cc,ss);
      	pRotZ(p[2],cc,ss);
      	vRotZ(v[1],cc,ss);
      	vRotZ(v[2],cc,ss);
      }
    }

//--------------------------------------------------------------------//
// \Fݒ肷
// color - ݒ肷\F
    public function setColor(c:uint):void{
      for(var i:int=0;i<pl.length;i++){
      	pl[i].setColor(c);
      }
    }

//--------------------------------------------------------------------//
// |S̐Ԃ
    public function getCount():int{
      return pl.length;
    }

//--------------------------------------------------------------------//
// |SԂ
// index - |SoCfbNX
    public function getPolygon(index:int):Polygon3D{
      return pl[index];
    }

//--------------------------------------------------------------------//
// _zɉ]
// p - ]_
// cc,ss - ]pcos,sin
    internal function pRotZ(p:Point3D,cc:Number,ss:Number):void{
      var tx:Number=cc*p.x-ss*p.y;
      var ty:Number=ss*p.x+cc*p.y;
      p.x=tx;
      p.y=ty;
    }

//--------------------------------------------------------------------//
// xNgzɉ]
// p - ]xNg
// cc,ss - ]pcos,sin
    internal function vRotZ(v:Vector3D,cc:Number,ss:Number):void{
      var tx:Number=cc*v.x-ss*v.y;
      var ty:Number=ss*v.x+cc*v.y;
      v.x=tx;
      v.y=ty;
    }
  }
}
