package shading{
  import flash.display.BitmapData;
  import flash.geom.Vector3D;
  import figure.Point3D;
  import figure.Polygon3D;

//--------------------------------------------------------------------//
// O[[VF[fBONX
  public class GouraudShading extends Shading{

//--------------------------------------------------------------------//
// O[[VF[fBOIuWFNg\z
// width,height - ʕE
// viewPoint - _
// lightPoint - 
// perspect - ϊꍇ true
    public function GouraudShading(width:int,height:int,
      	      	      	      	   viewPoint:Point3D,lightPoint:Point3D,
      	      	      	      	   perspect:Boolean):void{
      super(width,height,viewPoint,lightPoint,perspect);
    }

//--------------------------------------------------------------------//
// |S̃VF[fBO`vZ
// pl - |S
// image - ʕ\摜
// zbuf - zW̃obt@Xg
    public override function polygon(pl:Polygon3D,image:BitmapData,
      	      	      	      	     zbuf:Array):void{
      var n:int=pl.p.length;
      var ymax:int=0;
      var ymin:int=height-1;
      var s0:int=0;
      var s1:int=0;
      var ps:Vector.<Point3D>=new Vector.<Point3D>(n,true);
      var col:Vector.<uint>=new Vector.<uint>(n,true);
      for(var i:int=0;i<n;i++){
      	ps[i]=screen(pl.p[i]);
      	var viewV:Vector3D=Point3D.toVector(viewPoint,pl.p[i]);
      	viewV.normalize();
      	var lightv:Vector3D=Point3D.toVector(lightPoint,pl.p[i]);
      	lightv.normalize();
      	col[i]=LIGHT_MODEL.getColor(viewV,lightv,pl.nvp[i],pl.color,
      	      	      	      	    1.5,false);
      	ymax=Math.max(ymax,int(ps[i].y));
      	if(int(ps[i].y)<ymin){
      	  ymin=int(ps[i].y);
      	  s0=i;
      	  s1=i;
      	}
      	else if(int(ps[i].y)==ymin){
      	  s0=i;
      	}
      }
      ymin=Math.max(ymin,0);
      ymax=Math.min(ymax,height-1);
      for(var y:int=ymin;y<=ymax;y++){
      	if(int(ps[(s0+1)%n].y)<y) s0=(s0+1)%n;
      	if(int(ps[(s1-1+n)%n].y)<y) s1=(s1-1+n)%n;
      	var s2:int=(s0+1)%n;
      	var s3:int=(s1-1+n)%n;
      	var p1:Point3D=InterPolation.point(ps[s0],ps[s2],
      	      	      	      	      	   y-int(ps[s0].y),
      	      	      	      	      	   int(ps[s2].y)-y);
      	var p2:Point3D=InterPolation.point(ps[s1],ps[s3],
      	      	      	      	      	   y-int(ps[s1].y),
      	      	      	      	      	   int(ps[s3].y)-y);
      	var c1:uint=InterPolation.color(col[s0],col[s2],y-int(ps[s0].y),
      	      	      	      	      	int(ps[s2].y)-y);
      	var c2:uint=InterPolation.color(col[s1],col[s3],y-int(ps[s1].y),
      	      	      	      	      	int(ps[s3].y)-y);
      	var xmin:int=int(Math.max(Math.min(p1.x,p2.x),0));
      	var xmax:int=int(Math.min(Math.max(p1.x,p2.x),width-1));
      	for(var x:int=xmin;x<=xmax;x++){
      	  var p3:Point3D=InterPolation.point(p1,p2,x-int(p1.x),
      	      	      	      	      	     int(p2.x)-x);
      	  var c3:uint=InterPolation.color(c1,c2,x-int(p1.x),
      	      	      	      	      	  int(p2.x)-x);
      	  if(zbuf[x][y]<p3.z){
      	    image.setPixel(x,y,c3);
      	    zbuf[x][y]=p3.z;
      	  }
      	}
      }
    }
  }
}
